#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=Beta
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <file.au3>
#include <Array.au3>
#include <GuiConstants.au3>
Dim $array, $snrarray1, $snrarray2, $netstumblerarray, $file, $output, $temp, $date = "Unknown"
Dim $BSSID_Array[1], $SSID_Array[1], $FirstSeen_Array[1], $LastSeen_Array[1], $SignalHist_Array[1], $Lat_Array[1], $Lon_Array[1], $Auth_Array[1], $Encr_Array[1], $Type_Array[1], $Channel_Array[1]
GuiCreate("Netstumbler summary file to Vistumbler data file - By:Andrew Calcutt - v1.0", 530, 233,-1, -1)
GuiCtrlCreateLabel("Netstumbler Input File (.TXT)", 10, 10, 200, 20)
$netstumblerfileinput = GuiCtrlCreateInput("", 10, 30, 420, 20)
GuiCtrlCreateLabel("Vistumbler Output File (.TXT)", 10, 60, 200, 20)
$vistinput = GuiCtrlCreateInput("", 10, 80, 420, 20)
$browse1 = GuiCtrlCreateButton("Browse", 450, 30, 60, 20)
$browse2 = GuiCtrlCreateButton("Browse", 450, 80, 60, 20)
$scan = GuiCtrlCreateButton("Start", 190, 110, 110, 30)
$progressbar = GuiCtrlCreateProgress(10, 150, 490, 10)
GuiCtrlCreateLabel("Progress:", 10, 170, 50, 20)
$percentlabel = GuiCtrlCreateLabel("Ready", 60, 170, 160, 20)
GuiCtrlCreateLabel("Line/left:", 10, 190, 70, 20)
$line = GuiCtrlCreateLabel("", 60, 190, 160, 20)
GuiCtrlCreateLabel("Minutes:", 230, 170, 70, 20)
$minutes = GuiCtrlCreateLabel("", 290, 170, 70, 20)
GuiCtrlCreateLabel("Lines/Min:", 230, 190, 50, 20)
$linemin = GuiCtrlCreateLabel("", 290, 190, 60, 20)
GuiCtrlCreateLabel("Estimated time remaining:", 230, 210, 120, 20)
$estimatedtime = GuiCtrlCreateLabel("", 360, 210, 120, 20)
GuiCtrlCreateLabel("Total Lines:", 10, 210, 60, 20)
$totallines = GuiCtrlCreateLabel("", 80, 210, 130, 20)
GuiSetState()
While 1
	$msg = GUIGetMsg()
	Select
		Case $msg = $browse1
			GUICtrlSetData($netstumblerfileinput, FileOpenDialog("Select Netstumbler File", @ScriptDir, "Netstumbler File (*.txt)", 1))
		Case $msg = $browse2
			$temp = FileSaveDialog("Select Output Vistumbler File", @ScriptDir, "Vistumbler File (*.txt)")
			If @error <> 1 Then
				If StringInStr(StringRight ($temp, 4), ".txt") = 0 Then $temp &= ".txt"
				GUICtrlSetData($vistinput, $temp)
			EndIf
		Case $msg = $scan
			Dim $BSSID_Array[1], $SSID_Array[1], $FirstSeen_Array[1], $LastSeen_Array[1], $SignalHist_Array[1], $Lat_Array[1], $Lon_Array[1], $Auth_Array[1], $Encr_Array[1], $Type_Array[1]
			Dim $file = ""
			$vist = GUICtrlRead($vistinput)
			$netstumblerfile = GUICtrlRead($netstumblerfileinput)
			FileDelete($vist)
			;read ip address into array
			If Not _FileReadToArray($netstumblerfile, $netstumblerarray) Then
				MsgBox(4096, "Error", $netstumblerfile & 'Input File (' & $netstumblerfile & ')Not Found')
				Exit
			EndIf
			$begintime = TimerInit() ;starts counter
			GUICtrlSetData($totallines, $netstumblerarray[0])
			For $i = 1 To $netstumblerarray[0]
				_String($netstumblerarray[$i])
				$min = (TimerDiff($begintime) /60000) ;convert from miniseconds to minutes
				GUICtrlSetData($linemin, Round($i / $min, 4))
				GUICtrlSetData($minutes, Round($min, 4))
				GUICtrlSetData($line, $i & "/" & $netstumblerarray[0] - $i)
				GUICtrlSetData($estimatedtime, Round(($netstumblerarray[0] / Round($i / $min, 4))- $min, 4) & "/" & Round($netstumblerarray[0] / Round($i / $min, 4), 4))
			Next
			For $i = 1 To $BSSID_Array[0] ;Put data into vistumbler format
				$file &= $SSID_Array[$i] & "|" & $BSSID_Array[$i] & "|Unknown|0%|" & $Auth_Array[$i] & "|" & $Encr_Array[$i] & "|Unknown|" & $Channel_Array[$i] & "|" & $Lon_Array[$i] & "|" & $Lat_Array[$i] & "|Unknown|Unknown|" & $FirstSeen_Array[$i] & "|" & $LastSeen_Array[$i] & "|" & $Type_Array[$i] & "|Unknown|" & $SignalHist_Array[$i] & @CRLF
			Next
			FileWrite($vist, $file)
			GUICtrlSetData($progressbar, 100)
			GUICtrlSetData($percentlabel, "Done")
			;FileMove($output, $vist, 1)
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop
		Case Else
			;;;
	EndSelect
WEnd
Func _String($string)
	If StringInStr($string, "# $DateGMT:") Then 
		$date = StringTrimLeft($string, 12)
		$datereformat = StringSplit($date, "-")
		If $datereformat[0] = 3 Then $date = $datereformat[2] & "-" & $datereformat[3] & "-" & $datereformat[1]
	EndIf
	If StringLeft($string, 1) <> "#" Then
		$array = StringSplit($string, "	")
		If $string <> "" And IsArray($array) Then
				$HexIn = Number("0x" & $array[9])
				Global $ESS = False, $IBSS = False, $CFPoll = False, $CFPollReq = False, $WEP = False, $ShortPreAm = False, $PBCC = False, $ChAgile = False
				If BitAND($HexIn, 0x1) Then $ESS = True
				If BitAND($HexIn, 0x2) Then $IBSS = True
				If BitAND($HexIn, 0x10) Then $WEP = True
				$Type = ''
				If $HexIn Then
					If $ESS = True Then $Type &= "Infrastructure"
					If $IBSS = True Then $Type &= "Ad hoc"
				EndIf
				If $WEP = True Then
					$Encyption = "WEP"
					$Authentication = "Open"
				Else
					$Encyption = "None"
					$Authentication = "Open"
				EndIf
				$snrarray1 = StringSplit($array[7], " ")
				$SSID = StringTrimLeft(StringTrimRight($array[3], 2), 2)
				$BSSID = StringUpper(StringTrimLeft(StringTrimRight($array[5], 2), 2))
				$Time = StringTrimRight($array[6], 6)
				$Signal = StringReplace($snrarray1[3], "-", "*")
				$Longitude = StringReplace($array[1], "N 360.0000000", "N 0.0000000")
				$Latitude = StringReplace($array[2], "E 720.0000000", "E 0.0000000")
				$Channel = $array[13]
				$found = 0
					For $loop = 1 to $BSSID_Array[0]
						If $BSSID = $BSSID_Array[$loop] And $SSID = $SSID_Array[$loop] And $Type_Array[$loop] = $Type Then
							$LastSeen_Array[$loop] = $date & " " & $time & " 0"
							If StringInStr($Signal, "*") <> 1 Then $SignalHist_Array[$loop] &= "-" & $Signal
							If $Lat_Array[$loop] = "N 0.0000000" Then
								$Lat_Array[$loop] = $Latitude
								$Lon_Array[$loop] = $Longitude
							EndIf
							If $Channel_Array[$loop] = 0 Then $Channel_Array[$loop] = $Channel
							$found = 1
							ExitLoop
						EndIf
					Next
				If $found = 0 Then
					_ArrayAdd($BSSID_Array, $BSSID)
					_ArrayAdd($SSID_Array, $SSID)
					_ArrayAdd($FirstSeen_Array, $date & " " & $time & " 0")
					_ArrayAdd($LastSeen_Array, $date & " " &  $time & " 0")
					_ArrayAdd($SignalHist_Array, $Signal)
					_ArrayAdd($Lat_Array, $Latitude)
					_ArrayAdd($Lon_Array, $Longitude)
					_ArrayAdd($Auth_Array, $Authentication)
					_ArrayAdd($Encr_Array, $Encyption)
					_ArrayAdd($Type_Array, $Type)
					_ArrayAdd($Channel_Array, $Channel)
				EndIf
			;set progress
			$BSSID_Array[0] = UBound($BSSID_Array) - 1
			$percent = ($i / $netstumblerarray[0]) * 100
			GUICtrlSetData($progressbar, $percent)
			GUICtrlSetData($percentlabel, Round($percent, 4) & '% Array size:' & $BSSID_Array[0])
		EndIf
	EndIf
EndFunc   ;==>_String

